#include <windows.h>
#include "avisynth.h"
#include <stdlib.h>
#include <malloc.h>

#include "global.h"
//#include "xvid.h"
//#include "portab.h"

#include "fdct.h"
#include "idct.h"
#include "quant.h"
#include "quant_matrix.h"

//#define PROCESS_UV
//#define USE_Flat8
#define USE_6o9HVS

extern "C" {
void fdct_mmx_ffmpeg(short *const block);
void fdct_mmx_skal(short *const block);
void idct_mmx(short *const block);
void idct_xmm(short *const block);
};

void set_intra_matrix(uint16_t *mpeg_quant_matrices, const uint8_t * matrix);
//void quant_mpeg_intra_c(int16_t * coeff,const int16_t * data,const uint32_t quant,const uint32_t dcscalar,const uint16_t * mpeg_quant_matrices);
//void dequant_mpeg_intra_c(int16_t * coeff,const int16_t * data,const uint32_t quant,const uint32_t dcscalar,const uint16_t * mpeg_quant_matrices);
//extern "C" void __cdecl 

class SmoothD : public GenericVideoFilter {

/*

  Parameters:
	quant = 3 [1..31]
	num_shift = 4 [1, 3, 4, 6, 8]
	adaptive_shift = 0 [0, 1] 	// 1 means num_shift depends on quant ??which formula?? maybe mode (0=off)
	zero_weight = 1	[1..8]		// weight of zero shift

*/

  int quant;
  int num_shift;
  int adaptive_shift;
  int zero_weight;

  uint16_t *akkuY,     *akkuU,     *akkuV;			// buffers intermediate sum of pixel values
  uint16_t *akkuY_src, *akkuU_src, *akkuV_src;		// buffers the input (source)
  uint16_t *akkuY_tmp, *akkuU_tmp, *akkuV_tmp;		// processing takes place on this one

  int vi_sizey, vi_sizex; // dimensions of input video

  uint16_t quant_matrix[64*4];

  unsigned char Qp[64];

/*
// 6-of-9 HVS
	 8, 11, 12, 12, 13, 15, 16, 17
	11, 11, 12, 12, 14, 15, 16, 17
	12, 12, 13, 14, 15, 16, 17, 18
	12, 12, 14, 16, 17, 18, 19, 19
	13, 14, 15, 17, 19, 20, 20, 20
	15, 15, 16, 18, 20, 21, 22, 22
	16, 16, 17, 19, 21, 22, 23, 24
	17, 17, 18, 19, 20, 22, 24, 24
*/

/* 
// 6-of-9 original
	 8, 10, 11, 12, 12, 13, 14, 15
	10, 11, 12, 13, 13, 15, 15, 16
	11, 12, 12, 14, 15, 15, 16, 17
	12, 13, 14, 15, 15, 16, 17, 18
	12, 13, 15, 15, 16, 17, 18, 19
	13, 15, 15, 16, 17, 18, 19, 19
	14, 15, 16, 17, 18, 19, 19, 20
	15, 16, 17, 18, 19, 19, 20, 20
*/

public:
	SmoothD(PClip _child, const int _quant, const int _num_shift, const int _adaptive_shift, const int _zero_weight, IScriptEnvironment* env);

	~SmoothD();

	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);

	void DCT_Loop(int starti, int startj, int iblocks, int jblocks);
};